// Berarii - O (N * logN)

#include <cstdio>
#include <algorithm>
#include <string.h>
#include <vector>
using namespace std;

#define Nmax 100010
#define INF 999999999
#define LL long long

int N, K, nr;
int viz[Nmax];
int B[Nmax]; // B[nod] = cantitatea de bere ceruta in nod
LL Dmin[Nmax]; // Dmin[nod] = distanta (actuala) de la nod pana la cea mai apropiata berarie
LL Dmax[Nmax]; // Dmax[nod] = distanta maxima (stabilita prin cautare binara) a unei berarii fata de nod
LL Aux[Nmax]; // Aux[nod] = distanta maxima (IN SUS) la care pot sa plasez o berarie fata de nodul nod
               // Aux[nod] - cat a mai ramas din Dmax[nod] dupa ce m-am indepartat de cea mai apropiata berarie  
vector < pair <int, int> > V[Nmax];

void DFS (int nod, int cost) // costul muchiei pe care am intrat in nod
{

    viz[nod] = 1; Aux[nod] = Dmax[nod];
    for (vector<pair<int, int> >::iterator it = V[nod].begin(); it != V[nod].end(); it++)
        if (!viz[it->first]) 
        {
            DFS (it->first, it->second);

            Aux[nod] = min (Aux[nod], Aux[it->first] - it->second);
            Dmin[nod] = min (Dmin[nod], Dmin[it->first] + it->second);
        }

    if (nod == 1) {
        // daca nu pot sa ajung intr-o berarie o pun in radacina pentru ca n-am unde sa mai urc
        if (Aux[nod] < Dmin[nod]) nr++;
        return ;
    }

    if (Aux[nod] >= Dmin[nod]) {
        // pot ajunge la o berarie, nu mai conteza nodul asta
        Aux[nod] = INF;
    }
    else {
        // nu pot sa merg mai sus, pun o berarie in nod
        if (Aux[nod] - cost < 0) { // nu pot sa urc muchia
            Aux[nod] = INF;
            Dmin[nod] = 0;
            nr++;
        }
    }
}

LL cauta () 
{

    int i;
    // costul se cauta binar
    LL p = 0, u = (LL)1000 * 1000 * 1000 * 1000, mij, sol = 0;
    while (p <= u) {
        mij = (p + u) >> 1;

        nr = 0;
        for (i = 1; i <= N; i++) {
            Dmin[i] = INF;
            Aux[i] = INF;
            Dmax[i] = (LL)mij / (LL) B[i];         //  se fixeaza distantele care nu trebuie depasite pentru acest cost
            viz[i] = 0;
        }

        DFS (1, 0);

        if (nr <= K) sol = mij, u = mij - 1;
        else p = mij + 1;
    }

    return sol;
}

int main () {

    freopen ("berarii.in", "r", stdin);
    freopen ("berarii.out", "w", stdout);

    int i, T, x, y, cst;
    scanf ("%d", &T);
    for (; T; T--) {
        scanf ("%d %d", &N, &K);
        for (i = 1; i <= N; i++)
            scanf ("%d", &B[i]);

        for (i = 1; i < N; i++) {
            scanf ("%d %d %d", &x, &y, &cst);
            V[x].push_back (make_pair (y, cst));
            V[y].push_back (make_pair (x, cst));
        }

        printf ("%lld\n", cauta ());

        for (i = 1; i <= N; i++)
            V[i].clear ();
    }

    return 0;
}
