/* Algoritmul lui Dijkstra
 * O(n^2)
 */ 
#include <fstream>
#include <vector>
#include <queue>
using namespace std;

ifstream fin("graf.in");
ofstream fout("graf.out");

const int MaxN = 101, Inf = 0x3f3f3f3f;
int d[MaxN];        // d[x] = dism minima de la nodul sursa S la nodul x
int a[MaxN][MaxN];  // matricea ponderilor (a costurilor muchiilor)
bool s[MaxN];       // selectam nodurile care ajung la cost minim
int n;

void ReadGraph();
void Write();
void Dijkstra(int x, int d[]);

int main()
{
	ReadGraph();
	Dijkstra(1, d);
	Write();
}

void Dijkstra(int x, int d[])   // O(n^2)
{
	d[x] = 0;
	s[x] = true;
	
	for (int y = 1; y <= n; ++y)
		d[y] = a[x][y];
	for (int pas = 1; pas < n; ++pas)
	{
		int dmin = Inf, k;
		for (int y = 1; y <= n; ++y)
			if (d[y] < dmin && !s[y])
			{
				dmin = d[y];
				k = y;
			}
		s[k] = true;
		// acum, x e cel mai aproape nod de sursa
		
		for (int y = 1; y <= n; ++y)
			if (d[y] > d[k] + a[k][y])
				d[y] = d[k] + a[k][y];
	}
}

void ReadGraph()
{
	fin >> n;
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= n; ++j)
			if (i != j)
				a[i][j] = Inf;

	int x, y, w;       // w - ponderea muchiei
	while (fin >> x >> y >> w)
	{
		a[x][y] = a[y][x] = w;
	}
}

void Write()
{
	for (int i = 1; i <= n; ++i)
		fout << d[i] << ' ';
		
}
